package com.bqt 
{
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;
    import flash.media.*;
    import flash.net.*;
    
    public class AudioPlayer extends flash.display.Sprite
    {
        public function AudioPlayer(arg1:String=null, arg2:Boolean=true)
        {
            super();
            this._paused = false;
            this._audioFile = arg1;
            this.path = com.bqt.Config.TITLES_DIRECTORY + com.bqt.Config.ROOT_FOLDER + "/" + com.bqt.Config.AUDIO_DIRECTORY + "/" + this._audioFile + ".mp3";
            this.addEventListener(flash.events.Event.ADDED_TO_STAGE, this.onAddedToStage);
            this._soundPosition = 0;
            return;
        }

        public function get getAudioName():String
        {
            return this._audioFile;
        }

        internal function onAddedToStage(arg1:flash.events.Event):void
        {
            this.removeEventListener(flash.events.Event.ADDED_TO_STAGE, this.onAddedToStage);
            this.addEventListener(flash.events.MouseEvent.CLICK, this.onTouchTap);
            this.addEventListener(flash.events.Event.REMOVED_FROM_STAGE, this.onRemovedFromStage);
            this._controlsBar = new com.bqt.VideoControlsBar();
            this.addChild(this._controlsBar);
            this._controlsBar.togglefsMc.visible = false;
            this._controlsBar.pBar.videoSeekBar.scaleX = 0;
            this.setBackGround();
            var loc1:*;
            this._controlsBar.y = loc1 = 3;
            this._controlsBar.x = loc1;
            this._soundLoaderContext = new flash.media.SoundLoaderContext(2000, false);
            this._sound = new flash.media.Sound();
            this._sound.addEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onIOError);
            this._sound.load(new flash.net.URLRequest(this.path), this._soundLoaderContext);
            this._soundChannel = this._sound.play(this._soundPosition);
            if (this._soundChannel) 
            {
                this._soundChannel.addEventListener(flash.events.Event.SOUND_COMPLETE, this._onSoundComplete);
                this.addEventListener(flash.events.Event.ENTER_FRAME, this.onEnterFrame);
            }
            this.x = (stage.stageWidth - this.width) / 2;
            this.y = (stage.stageHeight - this.height) / 2 + 50;
            return;
        }

        internal function onRemovedFromStage(arg1:flash.events.Event=null):void
        {
            this.destroSoundObject();
            this.removeEventListener(flash.events.Event.ENTER_FRAME, this.onEnterFrame);
            this.removeEventListener(flash.events.MouseEvent.CLICK, this.onTouchTap);
            this.removeEventListener(flash.events.Event.REMOVED_FROM_STAGE, this.onRemovedFromStage);
            removeChild(this._controlsBar);
            this._controlsBar = null;
            this.graphics.clear();
            return;
        }

        internal function destroSoundObject():void
        {
            if (this._soundChannel) 
            {
                this._soundChannel.stop();
            }
            this._soundChannel = null;
            if (this._soundLoaderContext) 
            {
                this._soundLoaderContext = null;
            }
            if (this._sound) 
            {
                this._sound.removeEventListener(flash.events.Event.COMPLETE, this.onSoundLoaded);
                this._sound.removeEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onIOError);
            }
            this._sound = null;
            return;
        }

        internal function onSoundLoaded(arg1:flash.events.Event):void
        {
            if (this._soundChannel) 
            {
                this._soundChannel.stop();
            }
            this._soundChannel = (arg1.target as flash.media.Sound).play(0);
            return;
        }

        internal function _onSoundComplete(arg1:flash.events.Event):void
        {
            this._soundPosition = 0;
            this._soundChannel = this._sound.play(this._soundPosition);
            if (this._soundChannel) 
            {
                this._soundChannel.stop();
            }
            this._paused = true;
            return;
        }

        internal function onIOError(arg1:flash.events.IOErrorEvent=null):void
        {
            this.destroSoundObject();
            this.dispatchEvent(new com.bqt.FlipBookEvent(com.bqt.FlipBookEvent.SWF_PLAYER_REMOVED, true, true));
            return;
        }

        internal function onEnterFrame(arg1:flash.events.Event):void
        {
            if (this._paused) 
            {
                flash.display.MovieClip(this._controlsBar.ppClip).gotoAndStop("play");
            }
            else 
            {
                flash.display.MovieClip(this._controlsBar.ppClip).gotoAndStop("pause");
            }
            if (this._soundChannel && this._sound.length) 
            {
                this._controlsBar.pBar.videoSeekBar.scaleX = this._soundChannel.position / this._sound.length;
            }
            return;
        }

        internal function initActView():*
        {
            this.visible = true;
            return;
        }

        internal function onTouchTap(arg1:flash.events.MouseEvent):void
        {
            var loc1:*=NaN;
            var loc2:*=arg1.target.name;
            switch (loc2) 
            {
                case "quitVideoBtn":
                {
                    this.dispatchEvent(new com.bqt.FlipBookEvent(com.bqt.FlipBookEvent.SWF_PLAYER_REMOVED, true, true));
                    break;
                }
                case "playPauseVideoBtn":
                {
                    this._paused = !this._paused;
                    if (this._paused) 
                    {
                        if (this._soundChannel) 
                        {
                            this._soundChannel.stop();
                            this._soundPosition = this._soundChannel.position;
                        }
                    }
                    else if (this._sound.length) 
                    {
                        this._soundChannel = this._sound.play(this._soundChannel.position);
                    }
                    break;
                }
                case "toggleFsBtn":
                {
                    break;
                }
                case "pBar":
                {
                    loc1 = Math.floor(arg1.localX) / Math.floor(this._controlsBar.pBar.width) * this._sound.length;
                    this._soundChannel.stop();
                    this._soundChannel = null;
                    this._soundChannel = this._sound.play(loc1);
                    break;
                }
            }
            arg1.preventDefault();
            arg1.stopImmediatePropagation();
            arg1.stopPropagation();
            return;
        }

        internal function drawPbar(arg1:Number):*
        {
            this.ps.graphics.clear();
            this.ps.graphics.beginFill(8947848, 1);
            this.ps.graphics.drawRect(0, 0, arg1, 10);
            this.ps.graphics.endFill();
            return;
        }

        internal function setBackGround():void
        {
            this.graphics.clear();
            this.graphics.lineStyle(2, 13421772, 1, true, "normal", flash.display.CapsStyle.ROUND, flash.display.JointStyle.ROUND);
            var loc1:*=new flash.geom.Matrix();
            loc1.createGradientBox(PLAYER_WIDTH, PLAYER_HEIGHT, Math.PI / 2, 0, 0);
            this.graphics.beginGradientFill(flash.display.GradientType.LINEAR, [2767942, 3355443], [1, 1], [0, 255], loc1);
            this.graphics.drawRoundRectComplex(0, 0, PLAYER_WIDTH, PLAYER_HEIGHT, this.cornerRadius, this.cornerRadius, this.cornerRadius, this.cornerRadius);
            this.graphics.endFill();
            return;
        }

        internal const cornerRadius:int=5;

        public static const PLAYER_WIDTH:Number=326;

        public static const PLAYER_HEIGHT:Number=36;

        internal var _paused:Boolean;

        internal var path:String;

        internal var _seekWidth:Number;

        internal var _audioFile:String;

        internal var _controlsBar:com.bqt.VideoControlsBar;

        internal var _soundChannel:flash.media.SoundChannel;

        internal var _sound:flash.media.Sound;

        internal var _soundLoaderContext:flash.media.SoundLoaderContext;

        internal var _soundPosition:Number;

        var ps:flash.display.Shape;
    }
}
