﻿package com.bqt 
{
    import com.greensock.*;
    import fl.transitions.*;
    import fl.transitions.easing.*;
    import flash.display.*;
    import flash.events.*;
    import flash.filters.*;
    import flash.geom.*;
    import flash.ui.*;
    import flash.utils.*;
    
    public dynamic class FlipBook extends flash.display.Sprite
    {
        public function FlipBook(arg1:Number=858, arg2:Number=555, arg3:Number=112, arg4:Boolean=false)
        {
            this.leftPages = new Array();
            this.rightPages = new Array();
            super();
            this.origVals = new Object();
            this.pageHeight = arg2;
            this.pageWidth = arg1 / 2;
            this.bookWidth = arg1 + 2;
            this.bookHeight = this.pageHeight + 2;
            this._this = this;
            this.pageCount = arg3;
            if (arg4) 
            {
                this.startPage = 1;
            }
            this.addEventListener(flash.events.Event.ADDED_TO_STAGE, this.onAddedToStage);
            this.addEventListener(flash.events.Event.REMOVED_FROM_STAGE, this.onRemovedFromStage);
            return;
        }

        public function loadPageSet(arg1:*, arg2:*, arg3:Boolean=true, arg4:Number=1, arg5:Boolean=false):*
        {
            var leftPage:*;
            var rightPage:*;
            var autoFlip:Boolean=true;
            var depth:Number=1;
            var loadOpen:Boolean=false;
            var lp:com.bqt.FlipSection;

            var loc1:*;
            lp = null;
            leftPage = arg1;
            rightPage = arg2;
            autoFlip = arg3;
            depth = arg4;
            loadOpen = arg5;
            try 
            {
                this.isLoading = true;
                lp = new com.bqt.FlipSection(this.pageWidth, this.pageHeight);
                lp.x = 0;
                lp.y = this.pageHeight / 2;
                lp.flipSpeed = 50;
                lp.createFolio(leftPage, rightPage, autoFlip, loadOpen);
                addChildAt(lp, depth);
            }
            catch (er:Error)
            {
            };
            return;
        }

        internal function onMouseDown(arg1:*):*
        {
            var loc1:*=this.bookWidth * this.zoomLevel - this.bookWidth;
            var loc2:*=this.bookHeight * this.zoomLevel - this.bookHeight;
            this.startDrag(false, new flash.geom.Rectangle((stage.stageWidth + this.xOffset * 2 - loc1) / 2, (stage.stageHeight + this.yOffset * 2 - loc2) / 2, loc1, loc2));
            stage.addEventListener(flash.events.MouseEvent.MOUSE_UP, this.onMouseUp);
            return;
        }

        internal function onAddedToStage(arg1:flash.events.Event):*
        {
            this.removeEventListener(flash.events.Event.ADDED_TO_STAGE, this.onAddedToStage);
            this.setPageSequence(this.pageCount, this.startPage);
            this.addEventListener(com.bqt.FlipBookEvent.FORWARD_FLIP_COMPLETE, this.onFFFlipComplete);
            this.addEventListener(com.bqt.FlipBookEvent.BACKWARD_FLIP_COMPLETE, this.onBBFlipComplete);
            this.addEventListener(com.bqt.FlipBookEvent.PAGE_SET_LOADED, this.onSetComplete);
            this.addEventListener(com.bqt.FlipBookEvent.ZOOMED_IN, this.onZoomIn);
            this.addEventListener(com.bqt.FlipBookEvent.ZOOMED_OUT, this.onZoomOut);
            this.addEventListener(com.bqt.FlipBookEvent.ZOOM_RESET, this.onZoomReset);
            this.addEventListener(flash.events.MouseEvent.MOUSE_OVER, this.onMouseOver);
            this.addEventListener(flash.events.MouseEvent.MOUSE_OUT, this.onMouseOut);
            this.addEventListener(flash.events.MouseEvent.MOUSE_UP, this.onMouseUp);
            this.origVals.x = stage.stageWidth / 2 + this.xOffset;
            this.origVals.y = (stage.stageHeight / 2 + this.yOffset) - 10;
            this.origVals.scale = 1;
            this.x = this.origVals.x;
            this.y = this.origVals.y;
            this.lefEdge = this.x - this.width / 2;
            this.topEdge = this.y - this.height / 2;
            this.ScrollRect = new flash.geom.Rectangle(this.lefEdge, this.topEdge, this.width, this.height);
            this.coverGlow = new flash.filters.GlowFilter(0, 0.9, 10, 10, 2, 1);
            this.leftFlipButton = new com.bqt.FlipButton();
            this.rightFlipButton = new com.bqt.FlipButton();
            this.leftFlipButton.x = -this.pageWidth + 0.5;
            this.leftFlipButton.y = this.pageHeight / 2;
            this.leftFlipButton.scaleX = -1;
            this.leftFlipButton.name = "prev_page_btn";
            this.addChild(this.leftFlipButton);
            this.rightFlipButton.x = this.pageWidth - 0.5;
            this.rightFlipButton.y = this.pageHeight / 2;
            this.rightFlipButton.name = "next_Page_btn";
            this.leftFlipButton.mouseEnabled = false;
            this.rightFlipButton.mouseEnabled = false;
            this.addChild(this.rightFlipButton);
            this.createBookCover();
            return;
        }

        internal function onSectionLoaded(arg1:*):*
        {
            this.isLoading = false;
            return;
        }

        internal function onMouseOut(arg1:flash.events.MouseEvent):*
        {
            flash.ui.Mouse.cursor = flash.ui.MouseCursor.AUTO;
            return;
        }

        internal function onMouseOver(arg1:flash.events.MouseEvent):*
        {
            if (this.scaleX > 1) 
            {
                flash.ui.Mouse.cursor = flash.ui.MouseCursor.HAND;
            }
            else 
            {
                flash.ui.Mouse.cursor = flash.ui.MouseCursor.AUTO;
            }
            return;
        }

        public function createBookCover(arg1:String=null):*
        {
            if (!(this.HardBack == null) && this.HardBack.stage) 
            {
                this.removeChild(this.HardBack);
            }
            this.HardBack = null;
            if (arg1 != null) 
            {
                this.HardBack = new BookBack();
            }
            else 
            {
                this.HardBack = new flash.display.Sprite();
                this.HardBack.x = 0;
                this.HardBack.y = 0;
                this.HardBack.graphics.beginFill(16777215, 1);
                this.HardBack.graphics.drawRect((-this.bookWidth) / 2, (-this.bookHeight) / 2, this.bookWidth, this.bookHeight);
                this.HardBack.graphics.endFill();
            }
            this.HardBack.filters = [this.coverGlow];
            this.addChildAt(this.HardBack, 0);
            this.waitIcon = new com.bqt.Spinner();
            this.addChildAt(this.waitIcon, 1);
            this.loadPageSet(this.leftPages[this.startSetNumber], this.rightPages[this.startSetNumber], false, 1);
            return;
        }

        public function showNextPair():*
        {
            var loc1:*;
            try 
            {
                if (this.currentSet >= this.leftPages.length || this.isLoading || this.isFlipping) 
                {
                    this.rightFlipButton.gotoAndStop(1);
                    this.rightFlipButton.mouseEnabled = false;
                    return;
                }
                this.isFlipping = true;
                this.leftFlipButton.gotoAndStop(1);
                this.leftFlipButton.mouseEnabled = false;
                this.rightFlipButton.gotoAndStop(1);
                this.rightFlipButton.mouseEnabled = false;
                var loc3:*=((loc2 = this).currentSet + 1);
                loc2.currentSet = loc3;
                if (this.currentSet < 4) 
                {
                    this.currentFS = this.getChildAt(this.currentSet) as com.bqt.FlipSection;
                }
                else 
                {
                    this.currentFS = this.getChildAt(4) as com.bqt.FlipSection;
                }
                if (this.currentFS != null) 
                {
                    this.currentFS.flipAhead();
                    this.dispatchEvent(new flash.events.Event(com.bqt.FlipBookEvent.PAGE_FLIP_STARTED, true, true));
                }
                if (!(this.currentSet > 100)) 
                {
                };
            }
            catch (er:Error)
            {
            };
            return;
        }

        public function showPrevPair():*
        {
            var loc1:*;
            try 
            {
                if (this.currentSet <= 1 || this.isLoading || this.isFlipping) 
                {
                    this.leftFlipButton.gotoAndStop(1);
                    this.leftFlipButton.mouseEnabled = false;
                    return;
                }
                this.isFlipping = true;
                this.leftFlipButton.gotoAndStop(1);
                this.leftFlipButton.mouseEnabled = false;
                this.rightFlipButton.gotoAndStop(1);
                this.rightFlipButton.mouseEnabled = false;
                if (this.currentSet < 3) 
                {
                    this.currentFS = this.getChildAt(this.currentSet) as com.bqt.FlipSection;
                }
                else 
                {
                    this.currentFS = this.getChildAt(3) as com.bqt.FlipSection;
                }
                if (this.currentFS != null) 
                {
                    this.currentFS.flipBack();
                    this.dispatchEvent(new flash.events.Event(com.bqt.FlipBookEvent.PAGE_FLIP_STARTED, true, true));
                }
                if (!(this.currentSet > 100)) 
                {
                };
                var loc3:*=((loc2 = this).currentSet - 1);
                loc2.currentSet = loc3;
            }
            catch (er:Error)
            {
            };
            return;
        }

        internal function onSetComplete(arg1:*):*
        {
            var e:*;

            var loc1:*;
            e = arg1;
            try 
            {
                if (this.numChildren <= this.maxFolios + 3) 
                {
                    var loc3:*=((loc2 = this).startSetNumber + 1);
                    loc2.startSetNumber = loc3;
                    this.loadPageSet(this.leftPages[this.startSetNumber], this.rightPages[this.startSetNumber], false, this.numChildren - 2);
                }
                else 
                {
                    if (this.waitIcon != null) 
                    {
                        removeChild(this.waitIcon);
                        this.waitIcon = null;
                    }
                    this.currentSet = 1;
                    this.currentFS = this.getChildAt(this.currentSet) as com.bqt.FlipSection;
                    this.dispatchEvent(new flash.events.Event(com.bqt.FlipBookEvent.PAGE_FLIP_STARTED, true, true));
                    this.currentFS.flipAhead();
                    this.isLoading = false;
                    this.removeEventListener(com.bqt.FlipBookEvent.PAGE_SET_LOADED, this.onSetComplete);
                    this.addEventListener(com.bqt.FlipBookEvent.PAGE_SET_LOADED, this.onSectionLoaded);
                }
            }
            catch (er:Error)
            {
            };
            return;
        }

        internal function onForwardButton(arg1:*):*
        {
            return;
        }

        internal function onFFFlipComplete(arg1:*):*
        {
            var e:*;

            var loc1:*;
            e = arg1;
            try 
            {
                this.isFlipping = false;
                this.rightFlipButton.mouseEnabled = true;
                this.leftFlipButton.mouseEnabled = true;
                if (this.currentSet > 3 && !this.jumpToPageCalled) 
                {
                    this.isLoading = true;
                    this.dispatchEvent(new flash.events.Event(com.bqt.FlipBookEvent.PAGE_SET_LOAD_STARTED, true, true));
                    flash.utils.setTimeout(this.LoadNextPair, 200);
                }
                else if (this.jumpToPageCalled) 
                {
                    this.jumpToPageCalled = false;
                    this.isLoading = true;
                    this.bCount = 0;
                    this.dispatchEvent(new flash.events.Event(com.bqt.FlipBookEvent.PAGE_SET_LOAD_STARTED, true, true));
                    if (this.isChildAt(3)) 
                    {
                        this.removeChildAt(3);
                    }
                    this.loadPageSet(this.leftPages[this.startSetNumber - 3], this.rightPages[this.startSetNumber - 3], false, 3, true);
                    if (this.isChildAt(2)) 
                    {
                        this.removeChildAt(2);
                    }
                    this.loadPageSet(this.leftPages[this.startSetNumber - 4], this.rightPages[this.startSetNumber - 4], false, 2, true);
                }
                if (this.currentSet <= 1) 
                {
                    this.leftFlipButton.gotoAndStop(1);
                    this.leftFlipButton.mouseEnabled = false;
                }
                if (this.currentSet >= this.leftPages.length) 
                {
                    this.rightFlipButton.gotoAndStop(1);
                    this.rightFlipButton.mouseEnabled = false;
                }
                this.addChild(this.leftFlipButton);
                this.addChild(this.rightFlipButton);
            }
            catch (er:Error)
            {
            };
            return;
        }

        internal function onRequestedPageSequenceLoaded(arg1:*):*
        {
            var loc1:*;
            var loc2:*=((loc1 = this).bCount + 1);
            loc1.bCount = loc2;
            if (this.bCount == 2) 
            {
                this.isLoading = false;
                if (this.isSearchedPageAhead) 
                {
                    this.removeEventListener(com.bqt.FlipBookEvent.PAGE_SET_LOADED, this.onRequestedPageSequenceLoaded);
                    flash.utils.setTimeout(this.LoadNextPair, 200);
                    this.addEventListener(com.bqt.FlipBookEvent.PAGE_SET_LOADED, this.onSectionLoaded);
                }
                else 
                {
                    this.bCount = 2;
                    this.currentFS = this.getChildAt(3) as com.bqt.FlipSection;
                    this.currentFS.flipBack();
                    this.dispatchEvent(new flash.events.Event(com.bqt.FlipBookEvent.PAGE_FLIP_STARTED, true, true));
                    this.addEventListener(com.bqt.FlipBookEvent.FORWARD_FLIP_COMPLETE, this.onFFFlipComplete);
                    this.addEventListener(com.bqt.FlipBookEvent.BACKWARD_FLIP_COMPLETE, this.onBBFlipComplete);
                    this.jumpToPageCalled = true;
                }
            }
            return;
        }

        internal function loadLastThreePagesOnSearch(arg1:*):*
        {
            var loc1:*;
            var loc2:*=((loc1 = this).bCount + 1);
            loc1.bCount = loc2;
            if (this.bCount == 3) 
            {
                this.isLoading = false;
                this.addEventListener(com.bqt.FlipBookEvent.PAGE_SET_LOADED, this.onSectionLoaded);
                this.removeEventListener(com.bqt.FlipBookEvent.PAGE_SET_LOADED, this.loadLastThreePagesOnSearch);
                loc2 = ((loc1 = this).startSetNumber + 1);
                loc1.startSetNumber = loc2;
                this.dispatchEvent(new flash.events.Event(com.bqt.FlipBookEvent.PAGE_SET_LOAD_STARTED, true, true));
                flash.utils.setTimeout(this.LoadPreviousPair, 200);
            }
            return;
        }

        internal function onBBFlipComplete(arg1:*):*
        {
            var e:*;

            var loc1:*;
            e = arg1;
            try 
            {
                this.isFlipping = false;
                this.rightFlipButton.mouseEnabled = true;
                this.leftFlipButton.mouseEnabled = true;
                if (this.currentSet > 2 && !this.jumpToPageCalled) 
                {
                    this.isLoading = true;
                    this.dispatchEvent(new flash.events.Event(com.bqt.FlipBookEvent.PAGE_SET_LOAD_STARTED, true, true));
                    flash.utils.setTimeout(this.LoadPreviousPair, 200);
                }
                else if (this.jumpToPageCalled) 
                {
                    this.removeEventListener(com.bqt.FlipBookEvent.PAGE_SET_LOADED, this.onRequestedPageSequenceLoaded);
                    flash.utils.setTimeout(this.sendPageUpdateEvent, 100);
                    this.jumpToPageCalled = false;
                    this.isLoading = true;
                    this.bCount = 0;
                    if (this.isChildAt(5)) 
                    {
                        this.removeChildAt(5);
                    }
                    if (this.isChildAt(4)) 
                    {
                        this.removeChildAt(4);
                    }
                    if (this.isChildAt(3)) 
                    {
                        this.removeChildAt(3);
                    }
                    this.dispatchEvent(new flash.events.Event(com.bqt.FlipBookEvent.PAGE_SET_LOAD_STARTED, true, true));
                    var loc3:*=((loc2 = this).startSetNumber + 1);
                    loc2.startSetNumber = loc3;
                    this.loadPageSet(this.leftPages[this.startSetNumber], this.rightPages[this.startSetNumber], false, 3);
                    loc3 = ((loc2 = this).startSetNumber + 1);
                    loc2.startSetNumber = loc3;
                    this.loadPageSet(this.leftPages[this.startSetNumber], this.rightPages[this.startSetNumber], false, 4);
                    loc3 = ((loc2 = this).startSetNumber + 1);
                    loc2.startSetNumber = loc3;
                    this.loadPageSet(this.leftPages[this.startSetNumber], this.rightPages[this.startSetNumber], false, 5);
                    if (this.currentSet < 3) 
                    {
                        loc3 = ((loc2 = this).startSetNumber + 1);
                        loc2.startSetNumber = loc3;
                        if (this.isChildAt(6)) 
                        {
                            this.removeChildAt(6);
                        }
                        this.loadPageSet(this.leftPages[this.startSetNumber], this.rightPages[this.startSetNumber], false, 6);
                        this.addEventListener(com.bqt.FlipBookEvent.PAGE_SET_LOADED, this.onSectionLoaded);
                        if (this.isChildAt(1)) 
                        {
                            this.removeChildAt(1);
                        }
                    }
                    else 
                    {
                        this.addEventListener(com.bqt.FlipBookEvent.PAGE_SET_LOADED, this.loadLastThreePagesOnSearch);
                    }
                }
                if (this.currentSet <= 1) 
                {
                    this.leftFlipButton.gotoAndStop(1);
                    this.leftFlipButton.mouseEnabled = false;
                }
                if (this.currentSet >= this.leftPages.length) 
                {
                    this.rightFlipButton.gotoAndStop(1);
                    this.rightFlipButton.mouseEnabled = false;
                }
                this.addChild(this.leftFlipButton);
                this.addChild(this.rightFlipButton);
            }
            catch (er:Error)
            {
            };
            return;
        }

        internal function isChildAt(arg1:Number):Boolean
        {
            var depth:Number;
            var isThere:Boolean;

            var loc1:*;
            depth = arg1;
            isThere = false;
            try 
            {
                if (this.getChildAt(depth) == null) 
                {
                    isThere = false;
                }
                else 
                {
                    isThere = true;
                }
            }
            catch (er:Error)
            {
                isThere = false;
            }
            return isThere;
        }

        internal function sendPageUpdateEvent():*
        {
            this.dispatchEvent(new com.bqt.FlipBookEvent(com.bqt.FlipBookEvent.SEARCHED_PAGE_LOADED, true, true, {"leftPageNumber":this.leftPages[(this.currentSet - 1)], "rightPageNumber":this.rightPages[(this.currentSet - 1)]}));
            return;
        }

        internal function LoadNextPair():*
        {
            var loc1:*;
            try 
            {
                this.isLoading = true;
                var loc3:*=((loc2 = this).startSetNumber + 1);
                loc2.startSetNumber = loc3;
                this.loadPageSet(this.leftPages[this.startSetNumber], this.rightPages[this.startSetNumber], false, this.numChildren - 2);
                if (this.isChildAt(1)) 
                {
                    this.removeChildAt(1);
                }
            }
            catch (er:Error)
            {
            };
            return;
        }

        internal function LoadPreviousPair():*
        {
            var loc1:*;
            try 
            {
                this.isLoading = true;
                if (this.isChildAt(this.numChildren - 3)) 
                {
                    this.removeChildAt(this.numChildren - 3);
                }
                this.loadPageSet(this.leftPages[this.startSetNumber - 6], this.rightPages[this.startSetNumber - 6], false, 1, true);
                var loc3:*=((loc2 = this).startSetNumber - 1);
                loc2.startSetNumber = loc3;
            }
            catch (er:Error)
            {
            };
            return;
        }

        internal function onZoomReset(arg1:*):*
        {
            if (this.zoomLevel != 1) 
            {
                this.zoomLevel = 1;
            }
            this.removeEventListener(flash.events.MouseEvent.MOUSE_DOWN, this.onMouseDown);
            com.greensock.TweenMax.to(this, 0.25, {"scaleX":this.zoomLevel, "scaleY":this.zoomLevel, "x":this.origVals.x, "y":this.origVals.y});
            return;
        }

        internal function onZoomIn(arg1:*):*
        {
            this.zoomLevel = this.zoomLevel + 0.1;
            if (this.zoomLevel > MAX_ZOOM_LEVEL) 
            {
                this.zoomLevel = MAX_ZOOM_LEVEL;
            }
            this.animateTo(this.zoomLevel);
            if (this.zoomLevel > 1) 
            {
                this.addEventListener(flash.events.MouseEvent.MOUSE_DOWN, this.onMouseDown);
            }
            return;
        }

        internal function onZoomOut(arg1:*):*
        {
            this.zoomLevel = this.zoomLevel - 0.1;
            if (this.zoomLevel < this.origVals.scale) 
            {
                this.zoomLevel = this.origVals.scale;
            }
            if (this.zoomLevel == this.origVals.scale || this.scaleX == this.origVals.scale) 
            {
                this.removeEventListener(flash.events.MouseEvent.MOUSE_DOWN, this.onMouseDown);
                com.greensock.TweenMax.to(this, 0.25, {"x":this.origVals.x, "y":this.origVals.y});
                flash.ui.Mouse.cursor = flash.ui.MouseCursor.AUTO;
            }
            this.animateTo(this.zoomLevel);
            return;
        }

        public function ZoomTo(arg1:flash.geom.Rectangle):void
        {
            var loc1:*=this.bookWidth / arg1.width;
            this.zoomLevel = Math.min(MAX_ZOOM_LEVEL, Math.max(loc1, 1));
            var loc2:*=(arg1.x - (this.origVals.x - this.bookWidth / 2)) / this.bookWidth;
            var loc3:*=(arg1.y - (this.origVals.y - this.bookHeight / 2)) / this.bookHeight;
            var loc4:*=(this.bookWidth - this.bookWidth * this.zoomLevel) * loc2;
            var loc5:*=(this.bookHeight - this.bookHeight * this.zoomLevel) * loc3;
            com.greensock.TweenMax.to(this, 0.25, {"scaleX":this.zoomLevel, "scaleY":this.zoomLevel, "x":loc4, "y":loc5});
            this.addEventListener(flash.events.MouseEvent.MOUSE_DOWN, this.onMouseDown);
            return;
        }

        internal function onMouseUp(arg1:*):*
        {
            stage.removeEventListener(flash.events.MouseEvent.MOUSE_UP, this.onMouseUp);
            if (this.scaleX > this.origVals.scale) 
            {
                this.stopDrag();
            }
            return;
        }

        internal function animateTo(arg1:*):*
        {
            com.greensock.TweenMax.to(this, 0.25, {"scaleX":arg1, "scaleY":arg1});
            return;
        }

        public function get isZoomed():Boolean
        {
            return this.zoomLevel > this.origVals.scale;
        }

        internal function setPageSequence(arg1:*, arg2:Number=0):*
        {
            var loc1:*=arg2;
            while (loc1 <= arg1) 
            {
                if (loc1 % 2 != arg2) 
                {
                    this.rightPages.push(loc1);
                }
                else 
                {
                    this.leftPages.push(loc1);
                }
                ++loc1;
            }
            if (this.leftPages.length > this.rightPages.length) 
            {
                this.rightPages.push(0);
            }
            return;
        }

        public function gotoPage(arg1:Number):*
        {
            var pageNumber:Number;
            var pageSetIndex:Number;

            var loc1:*;
            pageSetIndex = NaN;
            pageNumber = arg1;
            try 
            {
                pageSetIndex = this.leftPages.indexOf(pageNumber);
                if (pageSetIndex == -1) 
                {
                    pageSetIndex = this.rightPages.indexOf(pageNumber);
                }
                if (pageSetIndex != -1) 
                {
                    if (this.currentSet == pageSetIndex + 1) 
                    {
                        return;
                    }
                    if (this.currentSet < pageSetIndex + 1) 
                    {
                        this.isSearchedPageAhead = true;
                    }
                    else 
                    {
                        this.isSearchedPageAhead = false;
                    }
                    this.startSetNumber = pageSetIndex;
                    this.currentSet = pageSetIndex + 1;
                    this.isLoading = true;
                    this.dispatchEvent(new flash.events.Event(com.bqt.FlipBookEvent.PAGE_SET_LOAD_STARTED, true, true));
                    this.removeEventListener(com.bqt.FlipBookEvent.FORWARD_FLIP_COMPLETE, this.onFFFlipComplete);
                    this.removeEventListener(com.bqt.FlipBookEvent.BACKWARD_FLIP_COMPLETE, this.onBBFlipComplete);
                    this.removeEventListener(com.bqt.FlipBookEvent.PAGE_SET_LOADED, this.onSectionLoaded);
                    if (this.isSearchedPageAhead) 
                    {
                        if (this.isChildAt(6)) 
                        {
                            this.removeChildAt(6);
                        }
                        if (this.isChildAt(5)) 
                        {
                            this.removeChildAt(5);
                        }
                        if (this.isChildAt(4)) 
                        {
                            this.removeChildAt(4);
                        }
                        this.loadPageSet(this.leftPages[this.startSetNumber], this.rightPages[this.startSetNumber], false, 4);
                        this.addEventListener(com.bqt.FlipBookEvent.PAGE_SET_LOADED, this.onRequestedPageSequenceLoadedFF);
                    }
                    else 
                    {
                        this.bCount = 0;
                        if (this.isChildAt(2)) 
                        {
                            this.removeChildAt(2);
                        }
                        this.loadPageSet(this.leftPages[this.startSetNumber], this.rightPages[this.startSetNumber], false, 2, true);
                        if (this.isChildAt(1)) 
                        {
                            this.removeChildAt(1);
                        }
                        this.loadPageSet(this.leftPages[(this.startSetNumber - 1)], this.rightPages[(this.startSetNumber - 1)], false, 1, true);
                        this.addEventListener(com.bqt.FlipBookEvent.PAGE_SET_LOADED, this.onRequestedPageSequenceLoaded);
                    }
                }
            }
            catch (er:Error)
            {
            };
            return;
        }

        internal function onRequestedPageSequenceLoadedFF(arg1:*):*
        {
            if (this.numChildren < this.maxFolios + 3) 
            {
                var loc1:*;
                var loc2:*=((loc1 = this).startSetNumber + 1);
                loc1.startSetNumber = loc2;
                this.loadPageSet(this.leftPages[this.startSetNumber], this.rightPages[this.startSetNumber], false, this.numChildren - 2);
            }
            else 
            {
                if (this.waitIcon != null) 
                {
                    removeChild(this.waitIcon);
                    this.waitIcon = null;
                }
                this.addEventListener(com.bqt.FlipBookEvent.FORWARD_FLIP_COMPLETE, this.onFFFlipComplete);
                this.addEventListener(com.bqt.FlipBookEvent.BACKWARD_FLIP_COMPLETE, this.onBBFlipComplete);
                this.removeEventListener(com.bqt.FlipBookEvent.PAGE_SET_LOADED, this.onRequestedPageSequenceLoadedFF);
                this.addEventListener(com.bqt.FlipBookEvent.PAGE_SET_LOADED, this.onRequestedPageSequenceLoaded);
                this.currentFS = this.getChildAt(4) as com.bqt.FlipSection;
                this.currentFS.flipAhead();
                this.dispatchEvent(new flash.events.Event(com.bqt.FlipBookEvent.PAGE_FLIP_STARTED, true, true));
                this.jumpToPageCalled = true;
            }
            return;
        }

        internal function onRemovedFromStage(arg1:*):*
        {
            this.removeEventListener(flash.events.Event.REMOVED_FROM_STAGE, this.onRemovedFromStage);
            this.removeEventListener(com.bqt.FlipBookEvent.FORWARD_FLIP_COMPLETE, this.onFFFlipComplete);
            this.removeEventListener(com.bqt.FlipBookEvent.BACKWARD_FLIP_COMPLETE, this.onBBFlipComplete);
            this.removeEventListener(com.bqt.FlipBookEvent.ZOOMED_IN, this.onZoomIn);
            this.removeEventListener(com.bqt.FlipBookEvent.ZOOMED_OUT, this.onZoomOut);
            this.removeEventListener(com.bqt.FlipBookEvent.ZOOM_RESET, this.onZoomReset);
            this.removeEventListener(com.bqt.FlipBookEvent.PAGE_SET_LOADED, this.onSectionLoaded);
            this.removeEventListener(flash.events.MouseEvent.MOUSE_OVER, this.onMouseOver);
            this.removeEventListener(flash.events.MouseEvent.MOUSE_OUT, this.onMouseOut);
            this.removeEventListener(flash.events.MouseEvent.MOUSE_UP, this.onMouseUp);
            while (this.numChildren) 
            {
                this.removeChildAt(0);
            }
            return;
        }

        internal static const MAX_ZOOM_LEVEL:Number=2;

        internal var isLoading:Boolean=false;

        internal var isFlipping:Boolean=false;

        internal var _this:*;

        internal var isSearchedPageAhead:Boolean=true;

        internal var origVals:Object;

        internal var HardBack:flash.display.Sprite;

        public var bookHeight:Number;

        public var bookWidth:Number;

        public var pageHeight:Number;

        public var pageWidth:Number;

        internal var jumpToPageCalled:Boolean=false;

        internal var bookLoader:flash.display.Loader;

        internal var coverGlow:flash.filters.GlowFilter;

        internal var currentFS:com.bqt.FlipSection;

        public var maxFolios:Number=6;

        public var currentSet:Number=1;

        internal var startSetNumber:Number=0;

        public var startPage:Number=0;

        public var pageCount:Number=6;

        internal var leftPageNum:Number=0;

        internal var rightPageNum:Number=0;

        internal var lefEdge:Number;

        internal var topEdge:Number;

        internal var zoomLevel:Number=1;

        internal var ScrollRect:flash.geom.Rectangle;

        internal var xTween:fl.transitions.Tween;

        internal var yTween:fl.transitions.Tween;

        internal var mouseInRightCorner:Boolean=false;

        public var xOffset:Number=0;

        public var yOffset:Number=0;

        internal var waitIcon:com.bqt.Spinner;

        internal var mouseInLeftCorner:Boolean=false;

        internal var leftFlipButton:com.bqt.FlipButton;

        internal var rightFlipButton:com.bqt.FlipButton;

        internal var leftPages:Array;

        internal var rightPages:Array;
    }
}
