package com.bqt 
{
    import flash.display.*;
    import flash.events.*;
    import flash.net.*;
    
    public class SWFPlayer extends flash.display.MovieClip
    {
        public function SWFPlayer(arg1:String=null)
        {
            super();
            this.paused = false;
            this.fullScreen = false;
            this._loadsActivity = false;
            this.addEventListener(flash.events.Event.ADDED_TO_STAGE, this.onAddedToStage);
            this._movieName = arg1;
            this.windowWidth = com.bqt.Config.MIN_PLAYER_WIDTH;
            this.windowHeight = com.bqt.Config.MIN_PLAYER_HEIGHT;
            this.path = com.bqt.Config.TITLES_DIRECTORY + com.bqt.Config.ROOT_FOLDER + "/" + com.bqt.Config.ANIMATION_DIRECTORY + "/" + this._movieName + ".swf";
            this.scaleRatio = 0;
            this.bgClip = new flash.display.Sprite();
            this.SWFLoader = new com.bqt.XLoader();
            return;
        }

        public function get getMovieName():String
        {
            return this._movieName;
        }

        internal function onAddedToStage(arg1:flash.events.Event):void
        {
            this.removeEventListener(flash.events.Event.ADDED_TO_STAGE, this.onAddedToStage);
            this.stop();
            this.addEventListener(flash.events.MouseEvent.CLICK, this.onMouseClick);
            this.addEventListener(flash.events.Event.REMOVED_FROM_STAGE, this.onRemovedFromStage);
            this.controls = new com.bqt.VideoControlsBar();
            this.controls.visible = false;
            this.addChild(this.controls);
            this.seekWidth = Math.floor(this.controls.pBar.width);
            this.controls.pBar.videoSeekBar.scaleX = 0;
            if (this._loadsActivity) 
            {
                var loc1:*;
                this.controls.pBar.visible = loc1 = false;
                this.controls.ppClip.visible = loc1;
                this.path = com.bqt.Config.TITLES_DIRECTORY + com.bqt.Config.ROOT_FOLDER + "/" + com.bqt.Config.ACTIVITY_DIRECTORY + "/" + this._movieName + ".swf";
            }
            this.toggleFullScreenMc = this.controls.getChildByName("togglefsMc") as flash.display.MovieClip;
            this.SWFLoader.contentLoaderInfo.addEventListener(flash.events.Event.COMPLETE, this.onSWFLoadComplete);
            this.SWFLoader.contentLoaderInfo.addEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onIOError);
            this.SWFLoader.addEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onIOError);
            this.SWFLoader.load(new flash.net.URLRequest(this.path));
            return;
        }

        internal function onRemovedFromStage(arg1:flash.events.Event):void
        {
            this.removeEventListener(flash.events.Event.ENTER_FRAME, this.onEnterFrame);
            this.removeEventListener(flash.events.MouseEvent.CLICK, this.onMouseClick);
            this.removeEventListener(flash.events.Event.REMOVED_FROM_STAGE, this.onRemovedFromStage);
            if (this.movie) 
            {
                this.movie = null;
            }
            if (this.SWFLoader) 
            {
                this.SWFLoader.contentLoaderInfo.removeEventListener(flash.events.Event.COMPLETE, this.onSWFLoadComplete);
                this.SWFLoader.contentLoaderInfo.removeEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onIOError);
                this.SWFLoader.removeEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onIOError);
                removeChild(this.SWFLoader);
                this.SWFLoader = null;
            }
            removeChild(this.controls);
            this.graphics.clear();
            return;
        }

        internal function onEnterFrame(arg1:flash.events.Event):void
        {
            if (this.movie && this.movie.isPlaying) 
            {
                this.controls.pBar.videoSeekBar.scaleX = this.movie.currentFrame / this.movie.totalFrames;
                flash.display.MovieClip(this.controls.ppClip).gotoAndStop("pause");
            }
            else 
            {
                flash.display.MovieClip(this.controls.ppClip).gotoAndStop("play");
            }
            if (this.movie.currentFrame == this.movie.totalFrames) 
            {
                this.movie.stop();
            }
            return;
        }

        internal function onMouseClick(arg1:flash.events.MouseEvent):*
        {
            var loc1:*=arg1.target.name;
            switch (loc1) 
            {
                case "quitVideoBtn":
                {
                    this.dispatchEvent(new com.bqt.FlipBookEvent(com.bqt.FlipBookEvent.SWF_PLAYER_REMOVED, true, true));
                    break;
                }
                case "playPauseVideoBtn":
                {
                    if (this.movie && this.movie.isPlaying) 
                    {
                        if (this.movie) 
                        {
                            this.movie.stop();
                        }
                    }
                    else if (this.movie) 
                    {
                        this.movie.play();
                    }
                    break;
                }
                case "toggleFsBtn":
                {
                    this.fullScreen = !this.fullScreen;
                    if (this.fullScreen) 
                    {
                        if (this.movie) 
                        {
                            this.setFullScreenView();
                        }
                    }
                    else if (this.movie) 
                    {
                        this.setNormalView();
                    }
                    break;
                }
                case "pBar":
                {
                    if (this.movie) 
                    {
                        this.movie.stop();
                        this.movie.gotoAndPlay(Math.ceil(arg1.localX / this.seekWidth * this.movie.totalFrames));
                    }
                    break;
                }
            }
            arg1.preventDefault();
            arg1.stopImmediatePropagation();
            return;
        }

        internal function onSWFLoadComplete(arg1:flash.events.Event):*
        {
            var e:flash.events.Event;

            var loc1:*;
            e = arg1;
            try 
            {
                this.SWFLoader.contentLoaderInfo.removeEventListener(flash.events.Event.COMPLETE, this.onSWFLoadComplete);
                this.SWFLoader.contentLoaderInfo.removeEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onIOError);
                this.SWFLoader.removeEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onIOError);
                this.movie = flash.display.MovieClip(e.target.content);
                if (!this.movie) 
                {
                    return;
                }
                this.scaleRatio = this.playerHeight / this.movie.loaderInfo.height;
                this.SWFLoader.x = 0;
                this.SWFLoader.y = 0;
                this.addChildAt(this.SWFLoader, 0);
                if (this._loadsActivity) 
                {
                    this.movie.gotoAndStop(1);
                    this.controls.visible = true;
                }
                else 
                {
                    this.movie.gotoAndPlay(2);
                    this.controls.visible = true;
                    this.addEventListener(flash.events.Event.ENTER_FRAME, this.onEnterFrame);
                }
                this.setFullScreenView();
            }
            catch (er:Error)
            {
                scaleRatio = 0;
            }
            return;
        }

        internal function onIOError(arg1:*):void
        {
            this.SWFLoader.contentLoaderInfo.removeEventListener(flash.events.Event.COMPLETE, this.onSWFLoadComplete);
            this.SWFLoader.contentLoaderInfo.removeEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onIOError);
            this.SWFLoader.removeEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onIOError);
            this.removeEventListener(flash.events.Event.ENTER_FRAME, this.onEnterFrame);
            this.removeEventListener(flash.events.MouseEvent.CLICK, this.onMouseClick);
            this.removeEventListener(flash.events.Event.REMOVED_FROM_STAGE, this.onRemovedFromStage);
            this.dispatchEvent(new com.bqt.FlipBookEvent(com.bqt.FlipBookEvent.SWF_PLAYER_REMOVED, true, true));
            return;
        }

        internal function setNormalView():void
        {
            this.fullScreen = false;
            if (this.toggleFullScreenMc) 
            {
                this.toggleFullScreenMc.gotoAndStop("full");
            }
            this.rotation = 0;
            this.playerWidth = this.windowWidth;
            this.playerHeight = this.windowHeight;
            this.controls.y = this.playerHeight - 35;
            this.controls.x = 0;
            this.controls.togglefsMc.x = this.playerWidth - 53;
            this.controls.pBar.width = this.playerWidth - 58 - this.controls.pBar.x;
            this.setVideoSize();
            this.x = Math.round(stage.stageWidth - this.windowWidth) / 2;
            this.y = Math.round(stage.stageHeight - this.windowHeight) / 2;
            this.setBackGround();
            this.fullScreen = false;
            return;
        }

        internal function setFullScreenView():void
        {
            this.fullScreen = true;
            if (this.toggleFullScreenMc) 
            {
                this.toggleFullScreenMc.gotoAndStop("normal");
            }
            this.playerWidth = com.bqt.Config.MAX_PLAYER_WIDTH;
            this.playerHeight = com.bqt.Config.MAX_PLAYER_HEIGHT;
            this.controls.y = this.playerHeight - 35;
            this.controls.x = 0;
            this.controls.togglefsMc.x = this.playerWidth - 53;
            this.controls.pBar.width = this.playerWidth - 58 - this.controls.pBar.x;
            this.setVideoSize();
            this.x = 0;
            this.y = 0;
            this.setBackGround();
            this.rotation = 0;
            this.fullScreen = true;
            return;
        }

        internal function setBackGround():void
        {
            this.graphics.clear();
            this.graphics.beginFill(2236962, 1);
            this.graphics.drawRect(0, 0, this.playerWidth, this.playerHeight);
            this.graphics.endFill();
            return;
        }

        internal function setVideoSize():*
        {
            if (!this.movie) 
            {
                return;
            }
            this.scaleRatio = this.playerHeight / this.movie.loaderInfo.height;
            if (this.scaleRatio * this.movie.loaderInfo.width > this.playerWidth) 
            {
                this.scaleRatio = this.playerWidth / this.movie.loaderInfo.width;
            }
            var loc1:*;
            this.SWFLoader.scaleY = loc1 = this.scaleRatio;
            this.SWFLoader.scaleX = loc1;
            this.SWFLoader.x = Math.floor((this.playerWidth - this.movie.loaderInfo.width * this.scaleRatio) / 2);
            this.SWFLoader.y = Math.floor((this.playerHeight - this.movie.loaderInfo.height * this.scaleRatio) / 2);
            addChildAt(this.bgClip, 0);
            this.bgClip.graphics.clear();
            this.bgClip.graphics.beginFill(0, 0.7);
            this.bgClip.graphics.drawRect((this.playerWidth - stage.stageWidth) / 2, (this.playerHeight - stage.stageHeight) / 2, stage.stageWidth, stage.stageHeight);
            this.bgClip.graphics.endFill();
            return;
        }

        public function set loadsActivity(arg1:Boolean):void
        {
            this._loadsActivity = arg1;
            if (this._loadsActivity && this.controls) 
            {
                var loc1:*;
                this.controls.pBar.visible = loc1 = false;
                this.controls.ppClip.visible = loc1;
            }
            return;
        }

        internal var paused:Boolean;

        internal var windowWidth:Number;

        internal var windowHeight:Number;

        internal var playerWidth:Number;

        internal var playerHeight:Number;

        internal var scaleRatio:Number;

        internal var path:String;

        internal var seekWidth:Number;

        internal var fullScreen:Boolean;

        internal var _movieName:String;

        internal var toggleFullScreenMc:flash.display.MovieClip;

        internal var movie:flash.display.MovieClip;

        internal var controls:com.bqt.VideoControlsBar;

        internal var SWFLoader:com.bqt.XLoader;

        internal var _loadsActivity:Boolean;

        internal var bgClip:flash.display.Sprite;
    }
}
