package com.bqt 
{
    import flash.display.*;
    import flash.events.*;
    import flash.media.*;
    import flash.net.*;
    import flash.utils.*;
    
    public dynamic class VideoPlayer extends flash.display.MovieClip
    {
        public function VideoPlayer(arg1:String=null)
        {
            this.seekPoints = new Array();
            super();
            this._video = arg1.replace("$", ".");
            this.path = new flash.net.URLRequest(com.bqt.Config.TITLES_DIRECTORY + com.bqt.Config.ROOT_FOLDER + "/" + com.bqt.Config.VIDEOS_DIRECTORY + "/" + this._video);
            this.addEventListener(flash.events.Event.ADDED_TO_STAGE, this.onAddedToStage, false, 2000, true);
            this.addEventListener(flash.events.MouseEvent.CLICK, this.onMouseClick, false, 2000, true);
            this.addEventListener(flash.events.Event.REMOVED_FROM_STAGE, this.onRemovedFromStage, false, 2000, true);
            this.onMetaData = this.onMetaDataEvent;
            this.onSeekPoint = this.onSeekPointEvent;
            this.totalTime = 0;
            this.paused = false;
            this.fullScreen = true;
            this.video = new flash.media.Video();
            this.nc = new flash.net.NetConnection();
            this.nc.connect(null);
            this.ns = new flash.net.NetStream(this.nc);
            this.ns.client = this;
            this.ns.addEventListener(flash.events.AsyncErrorEvent.ASYNC_ERROR, this.onAsyncError);
            this.ns.addEventListener(flash.events.NetStatusEvent.NET_STATUS, this.onNetStatus);
            this.videoBuffer = new flash.utils.ByteArray();
            this.seekBuffer = new flash.utils.ByteArray();
            this.urlStream = new flash.net.URLStream();
            this.urlStream.addEventListener(flash.events.Event.OPEN, this.onUrlStreamOpen);
            this.urlStream.addEventListener(flash.events.ProgressEvent.PROGRESS, this.onUrlStreamProgress);
            this.urlStream.addEventListener(flash.events.Event.COMPLETE, this.onStreamComplete);
            this.urlStream.addEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onIOError);
            return;
        }

        internal function onRemovedFromStage(arg1:*):*
        {
            this.dispose();
            return;
        }

        internal function initVideo():*
        {
            this.video.clear();
            this.video.attachNetStream(this.ns);
            this.video.smoothing = true;
            this.ns.play(null);
            return;
        }

        internal function onAddedToStage(arg1:flash.events.Event=null):void
        {
            this.removeEventListener(flash.events.Event.ADDED_TO_STAGE, this.onAddedToStage);
            this.toolBar = new com.bqt.VideoControlsBar();
            this.addChild(this.toolBar);
            this.seekWidth = Math.floor(this.toolBar.pBar.width);
            this.addChildAt(this.video, 0);
            this.bgClip = new flash.display.MovieClip();
            this.bgClip.graphics.beginFill(0, 0.6);
            this.bgClip.graphics.drawRect(0, 0, stage.stageWidth, stage.stageHeight);
            this.bgClip.graphics.endFill();
            this.addChildAt(this.bgClip, 0);
            this.setFullScreenView();
            this.toolBar.togglefsMc.gotoAndStop("normal");
            this.seekTime = 0;
            this.toolBar.pBar.videoSeekBar.scaleX = 0;
            this.urlStream.load(this.path);
            return;
        }

        internal function setNormalView():*
        {
            this.initW = Math.floor(com.bqt.Config.MIN_PLAYER_WIDTH);
            this.initH = Math.floor(com.bqt.Config.MIN_PLAYER_HEIGHT);
            this.toolBar.y = this.initH - 35;
            this.toolBar.x = 0;
            this.toolBar.togglefsMc.x = this.initW - 53;
            this.toolBar.pBar.width = this.initW - 58 - this.toolBar.pBar.x;
            this.setVideoSize();
            this.x = (stage.stageWidth - this.initW) / 2;
            this.y = (stage.stageHeight - this.initH) / 2;
            return;
        }

        internal function setFullScreenView():*
        {
            this.initW = Math.floor(com.bqt.Config.MAX_PLAYER_WIDTH);
            this.initH = Math.floor(com.bqt.Config.MAX_PLAYER_HEIGHT);
            this.toolBar.y = this.initH - 35;
            this.toolBar.x = 0;
            this.toolBar.togglefsMc.x = this.initW - 53;
            this.toolBar.pBar.width = this.initW - 58 - this.toolBar.pBar.x;
            this.setVideoSize();
            this.x = 0;
            this.y = 0;
            this.bgClip.x = this.x + (this.width - this.bgClip.width) / 2;
            this.bgClip.y = this.y + (this.height - this.bgClip.height) / 2;
            return;
        }

        internal function setVideoSize():void
        {
            if (this.aspectRatio == 0 || isNaN(this.aspectRatio)) 
            {
                this.aspectRatio = this.video.videoWidth ? this.video.videoWidth / this.video.videoHeight : this.initW / this.initH;
            }
            this.video.height = this.initH;
            this.video.width = this.initH * this.aspectRatio;
            this.scaleRatio = this.initW / this.video.videoWidth;
            if (this.video.width > this.initW) 
            {
                this.video.width = this.initW;
                this.video.height = this.initW * 1 / this.aspectRatio;
            }
            this.video.x = Math.floor((this.initW - this.video.width) / 2);
            this.video.y = Math.floor((this.initH - this.video.height) / 2);
            this.setBackGround();
            return;
        }

        internal function setBackGround():void
        {
            this.graphics.clear();
            this.graphics.beginFill(2236962, 1);
            this.graphics.drawRect((this.initW - stage.stageWidth) / 2, (this.initH - stage.stageHeight) / 2, stage.stageWidth, stage.stageHeight);
            this.graphics.endFill();
            return;
        }

        internal function onEnterFrame(arg1:flash.events.Event):*
        {
            if (this.ns && !(this.totalTime == 0)) 
            {
                this.toolBar.pBar.videoSeekBar.scaleX = Math.ceil(this.seekTime + this.ns.time) / this.totalTime;
            }
            if (this.paused) 
            {
                flash.display.MovieClip(this.toolBar.ppClip).gotoAndStop("play");
            }
            else 
            {
                flash.display.MovieClip(this.toolBar.ppClip).gotoAndStop("pause");
            }
            return;
        }

        internal function onMouseClick(arg1:flash.events.MouseEvent):*
        {
            var loc1:*=arg1.target.name;
            switch (loc1) 
            {
                case "quitVideoBtn":
                {
                    this.dispatchEvent(new com.bqt.FlipBookEvent(com.bqt.FlipBookEvent.VIDEO_PLAYER_REMOVED, true, true));
                    break;
                }
                case "playPauseVideoBtn":
                {
                    if (this.paused) 
                    {
                        if (this.ns) 
                        {
                            this.ns.resume();
                        }
                    }
                    else if (this.ns) 
                    {
                        this.ns.pause();
                    }
                    break;
                }
                case "toggleFsBtn":
                {
                    this.fullScreen = !this.fullScreen;
                    if (this.fullScreen) 
                    {
                        if (this.video) 
                        {
                            this.setFullScreenView();
                        }
                        flash.display.MovieClip(arg1.target.parent).gotoAndStop("normal");
                    }
                    else 
                    {
                        if (this.video) 
                        {
                            this.setNormalView();
                        }
                        flash.display.MovieClip(arg1.target.parent).gotoAndStop("full");
                    }
                    break;
                }
                case "pBar":
                {
                    if (this.totalTime != 0) 
                    {
                        this.ns.seek(Math.ceil(arg1.localX) / this.seekWidth * this.totalTime);
                    }
                    break;
                }
            }
            arg1.preventDefault();
            arg1.stopImmediatePropagation();
            return;
        }

        internal function onNetStatus(arg1:flash.events.NetStatusEvent):*
        {
            var loc1:*=undefined;
            var loc2:*=undefined;
            var loc3:*=arg1.info.code;
            switch (loc3) 
            {
                case "NetStream.Seek.Notify":
                {
                    this.i = 0;
                    while (this.i < this.seekPoints.length) 
                    {
                        if (this.seekPoints[this.i].timeStamp > arg1.info.seekPoint) 
                        {
                            loc1 = this.seekPoints[Math.max((this.i - 1), 0)].bytePosition;
                            loc2 = this.seekPoints[Math.max((this.i - 1), 0)].timeStamp;
                            break;
                        }
                        var loc4:*=((loc3 = this).i + 1);
                        loc3.i = loc4;
                    }
                    this.seekBuffer.clear();
                    this.videoBuffer.position = loc1 || 0;
                    this.videoBuffer.readBytes(this.seekBuffer);
                    this.ns.appendBytesAction(flash.net.NetStreamAppendBytesAction.RESET_SEEK);
                    this.ns.appendBytes(this.seekBuffer);
                    this.seekTime = loc2 || 0;
                    break;
                }
                case "NetStream.Play.Start":
                {
                    this.setVideoSize();
                    break;
                }
                case "NetStream.Play.Stop":
                {
                    this.ns.seek(0);
                    this.ns.pause();
                    break;
                }
                case "NetStream.Buffer.Empty":
                {
                    this.ns.seek(0);
                    this.ns.pause();
                    break;
                }
                case "NetStream.Pause.Notify":
                {
                    this.paused = true;
                    break;
                }
                case "NetStream.Unpause.Notify":
                {
                    this.paused = false;
                    break;
                }
            }
            return;
        }

        internal function onAsyncError(arg1:flash.events.AsyncErrorEvent):*
        {
            return;
        }

        internal function onSeekPointEvent(arg1:*, arg2:*):*
        {
            this.seekPoints.push({"timeStamp":arg1, "bytePosition":arg2});
            return;
        }

        internal function onMetaDataEvent(arg1:Object):void
        {
            var metadata:Object;

            var loc1:*;
            metadata = arg1;
            if (!this.totalTime) 
            {
                this.totalTime = Math.ceil(metadata.duration);
            }
            try 
            {
                this.aspectRatio = metadata.width ? metadata.width / metadata.height : 0;
            }
            catch (e:*)
            {
                scaleRatio = 0;
            }
            this.setVideoSize();
            return;
        }

        internal function onIOError(arg1:flash.events.IOErrorEvent):void
        {
            this.urlStream.removeEventListener(flash.events.Event.OPEN, this.onUrlStreamOpen);
            this.urlStream.removeEventListener(flash.events.ProgressEvent.PROGRESS, this.onUrlStreamProgress);
            this.urlStream.removeEventListener(flash.events.Event.COMPLETE, this.onStreamComplete);
            this.urlStream.removeEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onIOError);
            if (this.urlStream.connected) 
            {
                this.urlStream.close();
            }
            this.urlStream = null;
            this.dispatchEvent(new com.bqt.FlipBookEvent(com.bqt.FlipBookEvent.VIDEO_PLAYER_REMOVED, true, true));
            return;
        }

        internal function onUrlStreamOpen(arg1:flash.events.Event):void
        {
            return;
        }

        internal function onStreamComplete(arg1:flash.events.Event):void
        {
            this.initVideo();
            this.urlStream.readBytes(this.videoBuffer);
            this.ns.appendBytesAction(flash.net.NetStreamAppendBytesAction.RESET_BEGIN);
            this.processBytes(this.videoBuffer);
            this.ns.appendBytes(this.videoBuffer);
            this.urlStream.removeEventListener(flash.events.Event.OPEN, this.onUrlStreamOpen);
            this.urlStream.removeEventListener(flash.events.ProgressEvent.PROGRESS, this.onUrlStreamProgress);
            this.urlStream.removeEventListener(flash.events.Event.COMPLETE, this.onStreamComplete);
            this.urlStream.removeEventListener(flash.events.IOErrorEvent.IO_ERROR, this.onIOError);
            if (this.urlStream.connected) 
            {
                this.urlStream.close();
            }
            this.urlStream = null;
            this.addEventListener(flash.events.Event.ENTER_FRAME, this.onEnterFrame);
            this.paused = false;
            return;
        }

        internal function onUrlStreamProgress(arg1:flash.events.ProgressEvent):void
        {
            return;
        }

        internal function processBytes(arg1:flash.utils.ByteArray):void
        {
            var loc2:*=undefined;
            var loc1:*=com.bqt.Config.ENC_KEY;
            if (!loc1.length == 0) 
            {
                loc2 = 0;
                while (loc2 < 512) 
                {
                    arg1[loc2] = arg1[loc2] ^ loc1.charCodeAt(loc2 % loc1.length);
                    ++loc2;
                }
            }
            return;
        }

        public function get videoName():String
        {
            return this._video;
        }

        public function dispose():void
        {
            this.removeEventListener(flash.events.Event.ENTER_FRAME, this.onEnterFrame);
            this.removeEventListener(flash.events.MouseEvent.CLICK, this.onMouseClick);
            this.removeEventListener(flash.events.Event.REMOVED_FROM_STAGE, this.onRemovedFromStage);
            this.removeEventListener(flash.events.Event.ADDED_TO_STAGE, this.onAddedToStage);
            this.videoBuffer.clear();
            this.videoBuffer = null;
            this.seekBuffer.clear();
            this.seekBuffer = null;
            if (this.ns) 
            {
                this.ns.pause();
                this.ns.removeEventListener(flash.events.AsyncErrorEvent.ASYNC_ERROR, this.onAsyncError);
                this.ns.removeEventListener(flash.events.NetStatusEvent.NET_STATUS, this.onNetStatus);
                this.ns.close();
                this.ns.dispose();
                this.ns = null;
            }
            if (this.nc) 
            {
                this.nc.close();
                this.nc = null;
            }
            if (this.video) 
            {
                this.video.clear();
                if (this.video.loaderInfo.bytes) 
                {
                    this.video.loaderInfo.bytes.clear();
                }
            }
            this.graphics.clear();
            while (this.numChildren) 
            {
                this.removeChildAt(0);
            }
            this.video = null;
            this.seekPoints = null;
            this.onMetaData = null;
            this.onSeekPoint = null;
            return;
        }

        internal var initW:Number;

        internal var initH:Number;

        internal var totalTime:Number;

        internal var currentTime:Number;

        internal var scaleRatio:Number;

        internal var i:Number=0;

        internal var _video:String;

        internal var aspectRatio:Number;

        internal var path:flash.net.URLRequest;

        internal var video:flash.media.Video;

        internal var nc:flash.net.NetConnection;

        internal var ns:flash.net.NetStream;

        internal var seekPoints:Array;

        internal var urlStream:flash.net.URLStream;

        internal var videoBuffer:flash.utils.ByteArray;

        internal var seekBuffer:flash.utils.ByteArray;

        internal var toolBar:com.bqt.VideoControlsBar;

        internal var bgClip:flash.display.MovieClip;
    }
}
