﻿package com.bqt.audio {
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.net.URLRequest;
	import flash.media.SoundLoaderContext;
	import flash.media.SoundTransform;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.utils.getDefinitionByName;
	
	public class SoundLoop extends EventDispatcher{

		private var _sChannel:SoundChannel
		private var _soundName:String
		private var snd:Sound
		private var position:Number = 0
		private var _initialVolume:Number
		public function SoundLoop(soundId:String, volume:Number = 1) {
			// constructor code
			try
			{
				_initialVolume = volume
				_soundName = soundId
				var c:Class = getDefinitionByName(_soundName) as Class
				snd = new c() as Sound
			}
			catch(er:Error)
			{
				trace("SoundLoop", er.message)
			}
		}
			
		public function play():SoundChannel
		{
			try
			{
				position = 0
				if(_sChannel)
				{
					_sChannel.stop()
					 if(_sChannel.hasEventListener(Event.SOUND_COMPLETE))
					{
						_sChannel.removeEventListener(Event.SOUND_COMPLETE, onSndComplete)
					}
					_sChannel = null
				}
				if(snd)_sChannel = snd.play(position)
				if(_sChannel){
					setVolume(_initialVolume)
					_sChannel.addEventListener(Event.SOUND_COMPLETE, onSndComplete, false, 0, true)
				}
			}
			catch(er:Error)
			{
				_sChannel = null
				trace("SoundLoop->play", er.message)
			}
			return _sChannel
		}

		
		private function onSndComplete(e:Event)
		{
			this.play()
		}
		
		public function stop():void
		{
			if(_sChannel)
			{
				_sChannel.stop()
			}
		}
		
		
		public function pause():void
		{
			if(_sChannel)
			{
				position = _sChannel.position
				_sChannel.stop()
			}
		}
		
		public function setVolume(value:Number=1):void{
			if(_sChannel){
				_initialVolume = Math.min(value, 1)
				var st:SoundTransform = _sChannel.soundTransform
				st.volume = _initialVolume
				_sChannel.soundTransform = st
			}
		}
		
		public function resume():void
		{
			if(snd)snd.play(position)
		}
		
		public function kill():void
		{
			if(_sChannel)
			{
				_sChannel.stop()
				_sChannel.removeEventListener(Event.SOUND_COMPLETE, onSndComplete)
				_sChannel = null
				snd = null
			}
		}
		
	}
	
}
