﻿package com.bqt.audio {
	import flash.events.EventDispatcher;
	import flash.media.SoundChannel;
	import flash.events.Event;
	import flash.media.Sound;
	import flash.utils.getDefinitionByName;
	import flash.media.SoundMixer;
	import flash.media.SoundTransform;
	
	public class SoundPlayer extends EventDispatcher{


		public static const SOUND_COMEPLE:String = "sound_player_sound_complete";
		
		private static var loops:Object = new Object()
		private static var sChannel:SoundChannel
		private static var sChannel2:SoundChannel
		private static var fn:Function
		private static var sndQueue:Array
		private static var _volumeLevel:Number = 1
		private static var _currentLoop:String = ""
		
		public function SoundPlayer() {
			// constructor code
		}
		
		
		public static function playSound(soundQueue:String, callBack:Function=null, useAuxChannel:Boolean = false):void
		{
			if(sChannel && !useAuxChannel)
			{
				sChannel.stop(); 
				if(sChannel.hasEventListener(Event.SOUND_COMPLETE)){sChannel.removeEventListener(Event.SOUND_COMPLETE, processSoundQueue)}
				sChannel = null
			}
			else if(sChannel2)
			{
				try
				{
					sChannel2.stop(); 
					sChannel2 = null
					var snd:Sound
					var c:Class = getDefinitionByName(soundQueue.split(",")[0]) as Class
					snd = new c() as Sound
					sChannel2 = snd.play(0)
				}catch(er){}
			}
			sndQueue = soundQueue.split(",")
			fn = callBack
			processSoundQueue()
		}
		
		private static function processSoundQueue(e:Event=null)
		{
			var sndName:String
			try
			{
				if(sChannel && sChannel.hasEventListener(Event.SOUND_COMPLETE)){sChannel.removeEventListener(Event.SOUND_COMPLETE, processSoundQueue)}
				if(sndQueue.length)
				{
					sndName = sndQueue.shift()
					var snd:Sound
					var c:Class = getDefinitionByName(sndName) as Class
					snd = new c() as Sound
					sChannel = snd.play(0)
					sChannel.addEventListener(Event.SOUND_COMPLETE, processSoundQueue)
				}
				else
				{
					if(fn!=null)fn.apply(null, [{}])
					fn = null;
				}
			}
			catch(er:Error)
			{
				trace("playSound->", er.message)
				processSoundQueue()
			}
			
		}
		
		public static function addLoop(loopName:String, soundId:String, volume:Number = 1, autoPlay:Boolean = true):void
		{
			try
			{
				if(!loops.hasOwnProperty(loopName))
				{
					var snd:SoundLoop = new SoundLoop(soundId, volume)
					if(autoPlay)snd.play()
					loops[loopName] = snd
				}
				else
				{
					throw new Error("Redundancy Error: Sound loop by this name already exists.", 3001)
				}
			}
			catch(er:Error)
			{
				trace(er.message)
			}
			
		}
		
		public static function destroyLoop(loopName:String)
		{
			try
			{
				if(loops.hasOwnProperty(loopName))
				{
					var snd:SoundLoop = loops[loopName] as SoundLoop
					snd.kill()
					delete loops[loopName] 
					snd = null
				}
				else
				{
					throw new Error("Invalid Name Error: Sound loop by this name could not be found.", 3002)
				}
			}
			catch(er:Error)
			{
				trace(er.message)
			}
		}
		
		
		public static function stopLoop(loopName:String)
		{
			try
			{
				if(loops.hasOwnProperty(loopName))
				{
					var snd:SoundLoop = loops[loopName] as SoundLoop
					snd.stop()
					_currentLoop = ""
				}
				else
				{
					throw new Error("Invalid Name Error: Sound loop by this name could not be found.", 3002)
				}
			}
			catch(er:Error)
			{
				trace(er.message)
			}
		}
		
		
		public static function playLoop(loopName:String)
		{
			try
			{
				if(loops.hasOwnProperty(loopName))
				{
					if(_currentLoop!=loopName){
					var snd:SoundLoop = loops[loopName] as SoundLoop
					snd.play()
					_currentLoop=loopName
					}
				}
				else
				{
					throw new Error("Invalid Name Error: Sound loop by this name could not be found.", 3002)
				}
			}
			catch(er:Error)
			{
				trace(er.message)
			}
		}
		
		public static function set volumeLevel(level:Number)
		{
			var vol:Number = Math.min(Math.max(level, 0), 1)
			var st:SoundTransform = SoundMixer.soundTransform
			st.volume = vol
			SoundMixer.soundTransform = st
			_volumeLevel = vol
		}
	
		
		public static function get volumeLevel():Number
		{
			return _volumeLevel;
		}
		
		
		public static function stopAllSounds():void
		{
			SoundMixer.stopAll()
		}
		
	}
	
}
